#include "lenguage.h"

lenguage::lenguage()
{
   readSettings();
   langFileName = findQmFiles();
   if(langFileName.size() - 1 < activeLang)
      activeLang = -1;
}
QStringList lenguage::findQmFiles()
{
        QDir dir2(QCoreApplication::applicationDirPath());
        QDir::setCurrent(dir2.absolutePath());
#ifdef Q_OS_LINUX
   QDir dir("./translation");
   if(qApp->applicationDirPath() == "/usr/bin")
      dir = "/usr/share/qeven/translation";
#endif
#ifdef Q_OS_WIN32
   QDir dir = QDir(".\\translation\\");
#endif

   QStringList fileNames = dir.entryList(QStringList("*.qm"), QDir::Files,
                                         QDir::Name);
   QMutableStringListIterator i(fileNames);
   while (i.hasNext()) {
      i.next();
      i.setValue(dir.filePath(i.value()));
   }
   return fileNames;
}

void lenguage::Translate()
{
   QTranslator translator;
   translator.load(langFileName[activeLang] );
   qApp->installTranslator(&translator);

}

void lenguage::setActiveLang(int newActiveLang)
{
   activeLang = newActiveLang;
}

/**
 * Funcion para leer las configuraciones del sistema
 */
void lenguage::readSettings()
{
#ifdef Q_OS_LINUX
   QSettings settings(  QDir::homePath() + "/.QEVEN/config.ini", QSettings::IniFormat );
#else
   QSettings ini(QSettings::IniFormat,QSettings::UserScope,
                 QCoreApplication::organizationName(),
                 QCoreApplication::applicationName());
   QString dir = QFileInfo(ini.fileName()).absolutePath()+"/QEVEN/config.ini";
   QSettings settings( dir,  QSettings::IniFormat );
#endif
   activeLang = settings.value( "language", 0 ).toInt();
}
