/***************************************************************************
 *   Copyright (C) 2009 by QEVEN Team                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 **************************************************************************/

#include "mplayer_preview.h"
#include <stdexcept>

#ifdef Q_OS_WIN32
#include <Windows.h>
#endif

using namespace std;

Mplayer_Preview::Mplayer_Preview( QWidget *parent, Qt::WFlags flags ) :
      QWidget(parent, flags)
{
   this->mplayer = new QProcess();
}

Mplayer_Preview::~Mplayer_Preview()
{
   quit_mplayer();
}

void Mplayer_Preview::quit_mplayer()
{
   if( true == this->is_running_mplayer() )
   {
      // change de command to execute
#ifdef Q_OS_LINUX
      //this->program = "kill ";
      //this->program.append( QString::number( this->mplayer->pid() ) );
      // execute the new command
      //this->mplayer->execute( program );
      this->mplayer->execute( "killall -s KILL mplayer" );
      //this->mplayer->kill();
      this->close();
#endif
#ifdef Q_OS_WIN32
      this->mplayer->kill();
#endif
   }
   else
   {

   }

   // close the preview window
   this->close();
}

void Mplayer_Preview::preview_video( string file_name, string mplayerDir )
{
   args.clear();
   if( false == this->is_running_mplayer() )
   {
      program = mplayerDir.c_str();

      args << QString( file_name.c_str() );
      args << "-nosound";
      args << "-wid";
      args << QString::number((long)this->winId() );
#ifdef Q_OS_LINUX
      //  this->setWindowTitle( "Process ID: " + QString::number( mplayer->pid() ) );
      // this->setWindowTitle(tr("Previsualización"));
#endif
#ifdef Q_OS_WIN32
      args << "-vo";
      args << "directx:noaccel";
      //_PROCESS_INFORMATION* pInfo = (_PROCESS_INFORMATION*)this->mplayer->pid() ;
      //this->setWindowTitle( "Process ID: " + QString::number((unsigned long)pInfo->dwProcessId));
#endif
      mplayer->start( program, args );

   }
   else
   {
      throw new runtime_error( "There is another instance of \"mplayer\" running..." );
   }
}

bool Mplayer_Preview::is_running_mplayer()
{
   //return ( QProcess::Running == this->mplayer->state() ) ? true : false;
   if( QProcess::Running == this->mplayer->state() )
   {
      return true;
   }
   else
   {
      return false;
   }
}

void Mplayer_Preview::closeEvent(QCloseEvent *event)
{
   quit_mplayer();
}
